"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var PageData_1 = __importDefault(require("./PageData"));
var EventDispatcher_1 = __importDefault(require("../EventDispatcher"));
//import JSFunctions from "../libs/JSFunctions" ;
var maximomAcceptableParamsOnURL = 10;
var allPages = [];
var PageManager = {
    dispatcher: new EventDispatcher_1.default(),
    PAGE_CHANGED: "PAGE_CHANGED",
    routerParamList: '',
    changePage: changePage,
    decodePageParams: decodePageParams,
    getCurrentPage: getCurrentPage,
    registerPage: registerPage,
};
for (var i = 0; i < maximomAcceptableParamsOnURL; i++) {
    PageManager.routerParamList += '/:p' + i + '?';
}
///Page list ↓
function registerPage(page) {
    allPages.push(page);
}
var lastPage = new PageData_1.default();
function changePage(targetPage, pageData) {
    if (pageData === void 0) { pageData = []; }
    if (targetPage !== null) {
        lastPage = JSON.parse(JSON.stringify(targetPage));
        for (var i = 0; i < pageData.length; i++) {
            lastPage.url += '/' + encodeURIComponent(pageData[i]);
        }
        PageManager.dispatcher.dispatchEvent(PageManager.PAGE_CHANGED, lastPage);
    }
}
/**@description pass the constructor's props to the function and retrive parameters list */
function decodePageParams(props) {
    if (props === void 0) { props = {}; }
    if (props !== undefined &&
        props.match !== undefined &&
        props.match.params !== null) {
        var params = [];
        for (var i = 0; i < maximomAcceptableParamsOnURL; i++) {
            var par = props.match.params['p' + i];
            if (par !== undefined)
                params.push(decodeURIComponent(par));
            else
                break;
        }
        return params;
    }
    return null;
}
/**@return {PageData} */
function getCurrentPage() {
    /**@type {string} */
    var currentLocation = window.location.href.toLowerCase();
    for (var i = 0; i < allPages.length; i++) {
        /**@type {string} */
        var testLoc = allPages[i].url;
        if (currentLocation.indexOf(testLoc) !== -1) {
            return allPages[i];
        }
    }
    return null;
}
exports.default = PageManager;
//# sourceMappingURL=PageManager.js.map